#NoTrayIcon                                         ; Anweisung fr den AutoIt-Compiler:
                                                    ; Whrend des Programm luft, soll kein
                                                    ; Icon im Systemtray ausgegeben werden

$ProcessNameArray = ProcessList()                   ; Die Variable $ProcessNameArray 
                                                    ; enthlt die Funktion ProcessList()

$IfPhonerExists = ProcessList("phoner.exe")         ; Die Variable $IfPhonerExists enthlt
                                                    ; die Funktion ProcessList("phoner.exe")
                                                    ; Diese Funktionen werden jeweils ausgelst,
                                                    ; wenn die Variablen angesprochen werden

$PhonerProcessExists = "0"                          ; Bevor bekannt ist, ob eine Instanz der
                                                    ; phoner.exe aktiv ist, ist der Inhalt der
                                                    ; Variable $PhonerProcessExists "0"

Run("notepad.exe")                                  ; Um die Ausgaben verfolgen zu knnen, wird
                                                    ; der Texteditor "notepad.exe" gestartet

WinWaitActive("Unbenannt - Editor")                 ; Dieses Script soll warten, bis das Fenster
                                                    ; von "notepad.exe" aktiv ist

Send("Liste der aktiven Prozesse: {ENTER}{ENTER}")  ; Bevor nach einem Phoner-Prozess gesucht
                                                    ; wird, wird an das aktive Fenster dieser
                                                    ; Text gesendet

For $ProcessCounter = 1 to $ProcessNameArray[0][0]  ; Ein Zhler wird initiiert. Die Variable
                                                    ; $ProcessNameArray lst die Funktion
                                                    ; ProcessList() aus, die zwei Werte ausgibt:
                                                    ; [Prozess] und [PID]. Diese Werte werden
                                                    ; als "Array" (Variable mit mehreren Werten)
                                                    ; ausgegeben. Diese Anweisung bedeutet:
                                                    ; Beginne mit dem Zhlen bei "1". "1" ist der
                                                    ; erste laufende Prozess. Beende das Zhlen
                                                    ; wenn alle laufenden Prozesse gezhlt wurden
                                                    ; und fhre die nachfolgenden Anweisungen aus

    PhonerProcessProof("phoner.exe")                ; Die Funktion PhonerProcessProof() wird, da
                                                    ; innerhalb der Zhl-Schleife notiert, fr
                                                    ; jeden gezhlten Prozess aufgerufen
                                                    ; Gleichzeitig wird der Funktion ein String
                                                    ; bergeben ("phoner.exe"), der durch diese
                                                    ; Funktion "behandelt" werden soll.

next                                                ; Beendet die Zhlschleife und initiiert einen
                                                    ; Sprung zu den nchsten Anweisungen

If $PhonerProcessExists = "1" Then                  ; Nachdem die Funktion PhonerProcessProof()
                                                    ; whrend der Zhlschleife geprft hat, ob
                                                    ; ein Phoner-Prozess luft, wird mit dieser
                                                    ; Anweisung eine WennDann-Prfung eingeleitet

    OnPhonerExistsProof()                           ; Wenn ein Phoner-Prozess erkannt wurde, dann
                                                    ; nderte die Funktion PhonerProcessProof()
                                                    ; den Wert der eingangs deklarierten Variable
                                                    ; $PhonerProcessExists von "0" auf "1". In
                                                    ; diesem Fall wird durch die If-Then-Abfrage
                                                    ; die Funktion OnPhonerExitstProof() ausgelst

Else                                                ; anderenfalls wird der nachfolgende Text an
                                                    ; das aktive Notepad-Fenster gesendet, und

    Send("{ENTER}" & _
    "--------------------------------------------------" & _
    "{ENTER}" & _
    "Kein laufender Phoner-Prozess identifiziert." & _
    "{ENTER}" & _
    "--------------------------------------------------" & _
    "{ENTER}")

                                                    ; die nachfolgende Funktion StartPhonerOrNot()
                                                    ; ausgelst, der gleichzeitig zwei Strings
                                                    ; bergeben werden (damit erspart man sich,
                                                    ; in einer eigenen Anweisung den bergebenen
                                                    ; Text jeweils als Variabeln zu deklarieren)

    StartPhonerOrNot("Phoner wurde bisher nicht gestartet.", "Soll Phoner gestartet werden?")

EndIf                                               ; Ende der If-Anweisung

#comments-start 
---------------------------------------------------------------------------------------------------
Ab hier werden die Funktionen definiert, die vorstehend ausgelst werden, oder die im nachfolgenden
noch definiert sind. Da die folgenden Anweisungen im wesentlichen denen entsprechen, die bereits
vorstehend kommentiert wurden, wird ab hier lediglich die Funktionsweise jeder Funktion beschrieben
---------------------------------------------------------------------------------------------------
 Funktion:      PhonerProcessProof()
 Typ:           Benutzer-Definierte Funktion
 Beschreibung:  Diese Funktion berprft, ob whrend der Abfrage aller laufenden Prozesse
                mindestens ein "phoner.exe"-Prozess ermittelt werden kann. Falls diese Bedingung
                erfllt ist, wird einer vorher mit dem Wert "0" deklarierten Variable 
                $PhonerProcessExists der Wert "1" zugewiesen. Falls diese Bedingung nicht erfllt
                ist, erfolgt die Ausgabe einer Textzeile in ein aktives Fenster.
---------------------------------------------------------------------------------------------------
#comments-end

Func PhonerProcessProof($Process)
If $ProcessNameArray[$ProcessCounter][0] = $Process Then
    $PhonerProcessExists = "1"
Else 
    Send("PID: " & _
    $ProcessNameArray[$ProcessCounter][1] & _
    " " & _
    $ProcessNameArray[$ProcessCounter][0] & _
    "{ENTER}")
EndIf
EndFunc

#cs
---------------------------------------------------------------------------------------------------
 Funktion:      OnPhonerExistsProof()
 Typ:           Benutzer-Definierte Funktion
 Beschreibung:  Diese Funktion sendet einen Text an ein aktives Fenster. Anschliessend wird eine
                Zhlschleife initiiert. Innerhalb der Zhlschleife werden fr jedes Vorkommen des
                zu zhlenden Elements weitere Textzeilen an ein aktives Fenster gesendet, deren
                Inhalt teilweise aus Text und dem Inhalt ausgelesener Arrays besteht. Die nchste
                Anweisung nach der Schleife verweist auf die Funktion GotoExit() und enthlt einen
                String, der an GotoExit() bergeben wird.
---------------------------------------------------------------------------------------------------
#ce

Func OnPhonerExistsProof()
Send("{ENTER}" & _
"--------------------------------------------------" & _
"{ENTER}" & _
"Identifizierte Phoner-Prozesse:" & _
"{ENTER}" & _
"--------------------------------------------------" & _
"{ENTER}")
For $ProcessCounter = 1 to $IfPhonerExists[0][0]
    Send("PID: " & _ 
    $IfPhonerExists[$ProcessCounter][1] & _
    " " & _
    $IfPhonerExists[$ProcessCounter][0] & _
    "{ENTER}")
next
GotoExit("Es ist mindestens eine Phoner-Instanz bereits aktiv.")
EndFunc

#cs
---------------------------------------------------------------------------------------------------
 Funktion:      StartPhonerOrNot()
 Typ:           Benutzer-Definierte Funktion
 Beschreibung:  Diese Funktion deklariert zwei Variabeln, deren Inhalt durch eine andere Anweisung
                bergeben wurde. Im Anschluss wird eine Benutzerabfrage ausgelst. Je nach dem 
                Ergebnis dieser Abfrage wird zu der Funktion RunOpenDialog(), oder zu der Funktion
                GotoExit() verzweigt. Den beiden vorstehend genannten Funktionen wird jeweils ein 
                String bergeben.
---------------------------------------------------------------------------------------------------
#ce

Func StartPhonerOrNot($AskForStart, $Text)
$ask = MsgBox(32+4, $AskForStart, $Text)
If $ask = 6 Then
    RunOpenDialog("Bitte das Programmverzeichnis von Phoner auswhlen!")
ElseIf $ask = 7 Then
    GotoExit("Phoner sollte auf Benutzerwunsch nicht gestartet werden.")
EndIf
Endfunc

#cs
---------------------------------------------------------------------------------------------------
 Funktion:      RunOpenDialog()
 Typ:           Benutzer-Definierte Funktion
 Beschreibung:  Diese Funktion empfngt einen String, dessen Inhalt der Variable $AskForFile
                zugewiesen wird. Anschliessend wird ein Datei-ffnen-Dialog angezeigt. Bei Abbruch
                dieses Dialogs (If @error...) wird die Funktion GotoExit() aufgerufen, der ein 
                String bergeben wird. Anderenfalls wird eine erfolgreich ausgewhlte Datei 
                gestartet. Die Funktion wartet, bis das Fenster der gestarteten Datei aktiv ist, 
                und verzweigt zu der Funktion GotoExit(), der gleichzeitig ein String bergeben
                wird.
---------------------------------------------------------------------------------------------------
#ce

Func RunOpenDialog($AskForFile)
$OpenFile = FileOpenDialog($AskForFile, "C:\Programme\", "Ausfhrbare Dateien (*.exe)", 1 + 2, "phoner.exe")
If @error Then
    GotoExit("Der Vorgang wurde abgebrochen.")
Else
    Run($OpenFile)
    WinWaitActive("Phoner")
    GotoExit("Phoner wurde gestartet.")
EndIf
EndFunc

#cs
---------------------------------------------------------------------------------------------------
 Funktion:      GotoExit()
 Typ:           Benutzer-Definierte Funktion
 Beschreibung:  Die Funktion GotoExit() deklariert aus einem empfangenen String die Variable
                $ExitMessage. Anschliessend wird eine Benutzereingabe ausgelst, nach deren
                Besttigung das Programm endet.
---------------------------------------------------------------------------------------------------
#ce

Func GotoExit($ExitMessage)
$exit = MsgBox(0,"Abbruch",$ExitMessage & @CRLF & "Das Beispielprogramm wird beendet.")
EndFunc